<template>
  <div class="page-weighing">
    <app-header :sticky="true" />
    <div class="app-body">
      <div class="page-header bg-gradient-primary p-5 pb-5">
        <p class="text-center mb-5">
          <span>آخرین وزن ثبت شده از شما در زیره</span>
        </p>
      </div>
      <div class="logo-and-text" style="width:120px;margin-top: -50px">
        <div>
          <div class="content text-danger">
            <p class="mb-0 font-11">{{ weight || '--.--' }}</p>
            <p class="mb-0">کیلوگرم</p>
          </div>
        </div>
      </div>
      <div class="the-container">
        <loader :loading="loading" class="card">
          <div class="card-body">
            <p class="text-black text-bold text-center font-1">
              <span>وزن کشی برای امروز</span>
              <span>{{ $moment().format('jD jMMMM jYY') }}</span>
            </p>
            <p class="font-8 text-muted mt-3 mb-5">
              <span>بهتر است از آخرین وزن کشی شما</span>
              <span>حداقل 1 هفته گذشته باشد.</span>
              <span>بنابراین توصیه میشود که روزی از هفته</span>
              <span>را برای خود تعیین نموده و همیشه در</span>
              <span>آن روز وزن کشی کنید.</span>
            </p>
            <p class="text-center font-9 text-muted">وزن (کیلو)</p>
            <meter-slider
              v-model="form.weight"
              :min="40"
              :max="275"
              :step="1"
              :unit="50"
            />
            <p class="text-center font-9 text-muted mt-3">وزن (گرم)</p>
            <meter-slider
              v-model="form.weightGram"
              :min="0"
              :max="9"
              :step="1"
              :unit="50"
              :format="val => val * 100"
            />
            <div class="text-center mt-5">
              <button type="button" class="btn btn-success" @click="submit">
                ذخیره
              </button>
            </div>
          </div>
        </loader>

        <simple-chart
          :options="weightChartData"
          :ratio="9 / 21"
          title="10 وزن اخیر شما"
          class="mt-5"
        />
      </div>
    </div>
  </div>
</template>

<script>
import MeterSlider from '../helper/MeterSlider'
import SimpleChart from '../helper/SimpleChart'
export default {
  name: 'Weighing',
  components: { MeterSlider, SimpleChart },
  data() {
    return {
      loading: false,
      form: {
        weight: 90,
        weightGram: 0
      }
    }
  },
  computed: {
    weight() {
      let history = this.$store.state.home.weightHistory
      if (history.length) return history[0].weight

      let user = this.$store.state.user.data
      if (user && user.weight) return user.weight

      return 0
    },
    weightChartData() {
      let data = this.$store.state.home.weightHistory
      let result = {
        labels: [],
        series: [[]]
      }
      data
        .slice(0)
        .reverse()
        .forEach(item => {
          result.labels.push(
            this.$moment(item.createdAt, 'YYYY-MM-DD HH:mm:ss').format('jMM/jD')
          )
          result.series[0].push(item.weight)
        })
      return result
    }
  },
  watch: {
    weight: {
      handler(val) {
        if (val) {
          this.form.weight = Math.floor(val)
          this.form.weightGram = Math.round((val % 1) * 10)
        }
      },
      immediate: true
    }
  },
  created() {
    this.$store.dispatch('home/getDashboard')
  },
  methods: {
    submit() {
      let weight = this.form.weight + this.form.weightGram / 10
      this.$store
        .dispatch('tools/weighing', {
          $vm: this,
          $data: { weight }
        })
        .then(() => {
          this.$message.success('وزن جدید شما ثبت شد')
          this.$store.commit('home/reset')
          this.$router.push({ name: 'home' })
        })
    }
  }
}
</script>
